/*
 * Copyright (C) 2017  Kevin Whitaker <eyecreate@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#include "GroovePlayer.h"
#include "db/UserAction.h"
#include <Wt/WLogger>
#include <Wt/WServer>
#include <Wt/WApplication>
#include "WebInterface.h"

GroovePlayer::GroovePlayer(std::string dbFile) : sqliteConnection(dbFile)
{
    sqlSession.setConnection(this->sqliteConnection);
    sqlSession.mapClass<User>("user");
    sqlSession.mapClass<AudioTrack>("tracks");
    sqlSession.mapClass<UserAction>("actions");
    try
    {
        sqlSession.createTables();
    } catch(Wt::Dbo::Exception e) 
    {
        Wt::log("info") << "Using Existing DB.";
    }
    
    grooveAudioScanner = new std::thread(grooveAudioScannerLoop);
    grooveEvents = new std::thread(grooveEventLoop);
}

std::vector<AudioTrack*> GroovePlayer::getNextVoteBatch()
{
    //TODO
}

void GroovePlayer::grooveEventLoop()
{
    //TODO
}

void GroovePlayer::grooveAudioScannerLoop()
{
    //TODO
}




    //TODO:use this code when sending to UI.
//         Wt::WServer::instance()->postAll([]() {
//             Wt::WApplication* app = Wt::WApplication::instance();
//             if(app != nullptr)
//             {
//                 static_cast<WebInterface*>(app)->updateUIFromServer();
//             }
//         }
//         );

